
/**
 * Module dependencies.
 */

var Canvas = require('../')
  , exec = require('child_process').exec
  , fs = require('fs');

exports.render = function(frames, fn){
  var canvas = new Canvas(400, 400)
    , ctx = canvas.getContext('2d')
    , nframes = frames.length
    , pending = nframes
    , frame
    , calls
    , call;

  ctx.setFillStyle = function(val){
    ctx.fillStyle = val;
  };
  ctx.setStrokeStyle = function(val){
    ctx.strokeStyle = val;
  };
  ctx.setLineWidth = function(val){
    ctx.lineWidth = val;
  };
  ctx.setLineJoin = function(val){
    ctx.lineJoin = val;
  };
  ctx.setLineCap = function(val){
    ctx.lineCap = val;
  };

  for (var i = 0; i < nframes; ++i) {
    calls = frames[i];
    console.log('  rendering frame %d with %d calls', i, calls.length);

    // replay
    for (var j = 0, ncalls = calls.length; j < ncalls; ++j) {
      call = calls[j];
      ctx[call[0]].apply(ctx, call[1]);
    }

    // render
    renderFrame(i, canvas, function(err){
      if (err) {
        console.log(err);
        fn.error = true;
        fn.error || fn(err);
      } else {
        --pending || fn();
      }
    });
  }

  return canvas;
};

exports.compile = function(fn){
  exec('ffmpeg -r 24 -f image2 -i frames/frame-%d.png video.webm', function(err, stdout, stderr){
    if (err) return fn(err);
    fn(null, '/recording/video.webm');
  });
};

function renderFrame(i, canvas, fn) {
  fs.writeFile(__dirname + '/frames/frame-' + i + '.png', canvas.toBuffer(), fn);
}