
// 1440 == 60 seconds
// 24000ms render
// 39871ms compile

// 10 minutes
// 14400 frames
// 4 minute render
// 6.6 minute compile
// 10.6 minutes

/**
 * Module dependencies.
 */

var express = require('express')
  , playback = require('./playback');

var app = express.createServer();

app.use(express.favicon());
app.use(express.logger(' :method :url - :response-timems'));
app.use(express.bodyParser());

app.get('/recording/:file(*)', function(req, res){
  var file = req.params.file;
  res.sendfile(file, { root: __dirname });
});

app.post('/recording', function(req, res){
  if (!req.is('application/json')) return res.send(400);
  var frames = req.body;
  var start = new Date;
  console.log('  rendering %d frames', frames.length);
  var canvas = playback.render(frames, function(err){
    console.log('  render completed in %dms', new Date - start);
    start = new Date;
    console.log('  compiling .webm');
    if (err) throw err;
    playback.compile(function(err, file){
      if (err) throw err;
      console.log('  compile completed in %dms, %s created', new Date - start, 'video.webm');
      res.send(file);
    })
  });
});

app.use(express.static(__dirname));

app.listen(3000);